# Copyright (C) 2007 All right reserved by Shinya Kondo ( CGI KON )

	require "sample.inc" if(-e "sample.inc");

# 

	$SOFT_TITLE = qq!ھʾ!;

	$PAGE_TITLE = qq!ʾ!;

	$COPY_TITLE = qq!Powered by CGIKON!;

	@LIST_MAXNO = (0,1,2,3,4,5,6,7,8,9,10,15,20,25,30,35,40,45,50,60,70,80,90,100);

# üʸѴ

sub HTML_Chars
{
	my($value) = @_;

	$value =~ s/&/&amp;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;

	return $value;
}

# ƥ꡼󥯤ɽ

sub Print_Class
{
	my($href,$name,$value,@column) = @_;

	my($link);

	foreach (@LIST_LAY_0) {
		foreach (split(",")) {
			$link = $href.$name."=".$_;
			print qq!<NOBR><A HREF="$link">!;
			if($_ == $value) {
				print qq!<FONT SIZE=3 COLOR="Green"><B>$column[$_]</B></FONT>!;
			} else {
				print qq!<FONT SIZE=2 COLOR="Blue">$column[$_]</FONT>!;
			}
			print qq!</A></NOBR>\n!;
		}
		print "<BR>\n";
	}
}

# ȥ󥯤ɽ

sub Print_Reffer
{
	my($href,$value) = @_;

	my($class,$link,@result);

	foreach $class (split(",",$value)) {
		$link = $href."class=".$class;
		push(@result,qq!<A HREF="$link"><FONT SIZE=2 COLOR="blue">$LIST_CLASS[$class]</FONT></A>!);
	}

	print qq!<B><FONT SIZE=2 COLOR="Green">ڻȡۡ</FONT></B>!;
	print join("",@result);
}

# ǡΥ

sub Sort_Data
{
	my($items,$offset,$recmax,%values) = @_;

	my($key,$val,$loop,%column,@sorted,@result);

	while(($key,$val) = each(%values)) {
		$column{$key} = $values{$key}{"VALUE"}[$items];
	}

	@sorted = keys(%column);

	if($LIST_INPUT[$items] == 3) {
		if($SORT_TYPE == 1) {
			@sorted = sort { $column{$a} <=> $column{$b} } @sorted;
		} elsif($SORT_TYPE == 2) {
			@sorted = sort { $column{$b} <=> $column{$a} } @sorted;
		}
	} else {
		if($SORT_TYPE == 1) {
			@sorted = sort { $column{$a} cmp $column{$b} } @sorted;
		} elsif($SORT_TYPE == 2) {
			@sorted = sort { $column{$b} cmp $column{$a} } @sorted;
		}
	}

	for($loop = $offset;$loop < $offset + $recmax;$loop++) {
		push(@result,$sorted[$loop]) if($sorted[$loop]);
	}

	return @result;
}

# ǡμ

sub Get_Result
{
	my($class) = @_;

	my($key,$val1,$val2,@column,%result);

	if(open(IFILE,$DATA_FILE)) {
		$class = ",".$class."," if($class);
		while(<IFILE>) {
			chomp();
			($key,$val1,$val2,@column) = split("\t");
			next if($val2);

			$val1 = ",".$val1.",";
			next if($val1 !~ /$class/);

			$result{$key}{"CLASS"} = $val1;
			$result{$key}{"CLOSE"} = $val2;
			$result{$key}{"VALUE"} = [ @column ];
		}
		close(IFILE);
	}

	return %result;
}

# ǡμ

sub Search_Data
{
	my($keyword) = @_;

	my($key,$val1,$val2,$word,$match,@pattern,%result);

	if(open(IFILE,$DATA_FILE)) {
		foreach (split(/ |/,$keyword)) {
			push(@pattern,quotemeta($_)) if($_);
		}
		$count = scalar(@pattern);

		while(<IFILE>) {
			chomp();
			($key,$val1,$val2,$word) = split("\t",$_,4);
			next if($val2);

			$match = 0;
			foreach (@pattern) {
				last if($word !~ /$_/i);
				$match++;
			}
			next if($match != $count);

			$result{$key}{"CLASS"} = $val1;
			$result{$key}{"CLOSE"} = $val2;
			$result{$key}{"VALUE"} = [ split("\t",$word) ];
		}
		close(IFILE);
	}

	return %result;
}

# 쥳ɤμ

sub Get_Record
{
	my($recid) = @_;

	my($key,$val1,$val2,@column,%result);

	if(open(IFILE,$DATA_FILE)) {
		while(<IFILE>) {
			chomp();
			($key,$val1,$val2,@column) = split("\t");
			next if($val2);

			next if($key ne $recid);

			$result{$key}{"CLASS"} = $val1;
			$result{$key}{"CLOSE"} = $val2;
			$result{$key}{"VALUE"} = [ @column ];
		}
		close(IFILE);
	}

	return %result;
}

# ڡפɽ

sub Print_Pages
{
	my($href,$count,$page) = @_;

	my($loop,$max_page,$link);
	my($recmax) = $LIST_MAXNO[$VAL_MAXNO];

	$recmax = 10 if(!$recmax);
	$max_page = int($count / $recmax);
	$max_page += 1 if($count % $recmax);

	return if($max_page <= 1);

	print qq!
		<TABLE BORDER=0 WIDTH="90%" CELLPADDING="5" CELLSPACING="0">
			<TR>
			<TD>
			<FONT COLOR="Black" SIZE=2><B>[ڡ]</B></FONT>
	!;
	for($loop = 1;$loop <= $max_page;$loop++) {
		$link = $href."page=".$loop;
		if($loop != $page) {
			print qq!<A HREF="$link"><FONT COLOR="Blue" SIZE=2><B>$loop</B></FONT></A>!;
		} else {
			print qq!<A HREF="$link"><FONT COLOR="Black" SIZE=4><B>$loop</B></FONT></A>!;
		}
	}
	print qq!
			</TD>
			</TR>
		</TABLE>
	!;
}

1;

# Copyright (C) 2007 All right reserved by Shinya Kondo ( CGI KON )
